///home/berryj/link/bin/genMethods "-g" "-t" "Vertex*" "-h" "Collection" "-I" "LINK/basic/SetFuncs.h" "-I" "LINK/basic/Collection.h" "-I" "LINK/graph/Vertex.h" "-d" "graph" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/SetFuncs.h>

#include <LINK/basic/Collection.h>

#include <LINK/graph/Vertex.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/CollectionWrapper.h>


typedef Vertex* _Vertex_;
typedef Collection<Vertex* > _Collection_Vertex__;

#define _Collection_Vertex__DATA(x) ((Collection<Vertex* >*) (EXTDATA(x)))
#define _Collection_Vertex__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Vertex* > >::type))
#define _Collection_Vertex__ISNT_DATA(x) (!_Collection_Vertex__IS_DATA(x))

#define _Collection_Vertex__CXX_DATA(x) (*(Collection<Vertex* >*) (EXTDATA(VAL(x))))
#define _Collection_Vertex__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<Collection<Vertex* > >::type))
#define _Collection_Vertex__CXX_ISNT_DATA(x) (!_Collection_Vertex__CXX_IS_DATA(x))


PRIMITIVE STk_init__Collection_Vertex__()
{
	Wrapper<_Collection_Vertex__>::type = STk_new_CXXwrapper_id(
			Wrapper<_Collection_Vertex__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			CollectionWrapper<_Vertex_>::displayTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Vertex_>::markTypedCollection,
			(void (*)(SCM x))CollectionWrapper<_Vertex_>::freeTypedCollection);
	Tcl_InitHashTable(&Register<_Collection_Vertex__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_Collection_Vertex__Methods(void);

PRIMITIVE STk_init_methods__Collection_Vertex__()
{
	STk_add_new_cpp_primitive("collection-Vertex?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collectionP);
	STk_add_new_cpp_primitive("mset-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::buildMSet);
	STk_add_new_cpp_primitive("set-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::buildSet);
	STk_add_new_cpp_primitive("sequence-Vertex1", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::buildSequence);
	STk_add_new_cpp_primitive("Collection-Vertex-sorted?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::sortedLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-size", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::sizeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-null?", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::nullLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-eqv?", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::eqvLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-<", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::lthLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-<=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::leLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex->", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::grLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex->=", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::geLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-member", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::memberLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-clear!", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::clearLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-insert!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::insertLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-append!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::appendLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-remove!", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::removeLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-occurrences", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::occurrencesLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-ref", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::refLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-rank", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::rankLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-+", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::unionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-^", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::intersectionLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex--", tc_subr_1_or_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::differenceLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::subsetLinkCollection);
	STk_add_new_cpp_primitive("Collection-Vertex-proper-subset", tc_subr_2, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::properSubsetLinkCollection);
	STk_add_new_cpp_primitive("list->mset-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::stkList2LinkMSet);
	STk_add_new_cpp_primitive("list->set-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::stkList2LinkSet);
	STk_add_new_cpp_primitive("list->sequence-Vertex", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::stkList2LinkSequence);
	STk_add_new_cpp_primitive("mset-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collection2STkList);
	STk_add_new_cpp_primitive("set-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collection2STkList);
	STk_add_new_cpp_primitive("sequence-Vertex->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collection2STkList);
	STk_add_new_cpp_primitive("mset-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collection2STkString);
	STk_add_new_cpp_primitive("set-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collection2STkString);
	STk_add_new_cpp_primitive("sequence-Vertex->string", tc_subr_1, 
	(PRIMITIVE (*)(...))  CollectionWrapper<_Vertex_>::collection2STkString);

	addListMethod("mset-Vertex",
		"mset-Vertex1", LINK_NEW);
	addListMethod("set-Vertex",
		"set-Vertex1", LINK_NEW);
	addListMethod("sequence-Vertex",
		"sequence-Vertex1", LINK_NEW);
	addOneArgMethod("null?",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-null?", LINK_OVL);
	addOneArgMethod("size",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-size", LINK_NEW);
	addTwoArgMethod("eqv?",
		Wrapper<_Collection_Vertex__ >::name, 
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-eqv?", LINK_OVL);
	addBooleanMethod("<",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-<", LINK_OVL);
	addBooleanMethod("<=",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-<=", LINK_OVL);
	addBooleanMethod(">",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex->", LINK_OVL);
	addBooleanMethod(">=",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex->=", LINK_OVL);
	addTwoArgMethod("member",
		Wrapper<_Vertex_ >::name, 
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-member", LINK_OVL);
	addTwoArgMethod("ref",
		Wrapper<_Collection_Vertex__ >::name, 
		"<integer>",
		"Collection-Vertex-ref", LINK_NEW);
	addOneArgMethod("clear!",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-clear!", LINK_NEW);
	addTwoArgMethod("insert!",
		Wrapper<_Vertex_ >::name, 
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-insert!", LINK_NEW);
	addTwoArgMethod("append!",
		Wrapper<_Vertex_ >::name, 
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-append!", LINK_NEW);
	addTwoArgMethod("remove!",
		Wrapper<_Vertex_ >::name, 
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-remove!", LINK_NEW);
	addArbMethod("+",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-+", LINK_OVL);
	addArbMethod("^",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex-^", LINK_NEW);
	addArbMethod("-",
		Wrapper<_Collection_Vertex__ >::name, 
		"Collection-Vertex--", LINK_OVL);
	genExtra_Collection_Vertex__Methods();
	return UNDEFINED;
}
